package  
{
	import flash.text.TextFormat;
	
	/**
	 * ColorScheme
	 * Static storage of UI element colours.
	 * @author Charlie Chao
	 */
	public class CommonStyle 
	{
		/**
		 * Colors
		 */
		// main
		public static const COLOR_PRIMARY:uint = 0x3A2C14;
		public static const COLOR_SECONDARY:uint = 0xEEDA9B;
		public static const COLOR_TERTIARY:uint = 0xA84818;
		// placeholder
		 public static const PLACEHOLDER_COLOR:uint = 0x91FF00;
		// panels
		public static const PANEL_COLOR_BG:uint = COLOR_PRIMARY;
		public static const PANEL_COLOR_TITLE_BAR:uint = COLOR_TERTIARY;
		public static const PANEL_COLOR_TITLE:uint = COLOR_SECONDARY;
		//buttons
		public static const BUTTON_COLOR_LABEL:uint = COLOR_PRIMARY;
		public static const BUTTON_COLOR_BG:uint = COLOR_SECONDARY;
		public static const BUTTON_COLOR_BG_DOWN:uint = COLOR_TERTIARY;
		// side buttons
		public static const SIDE_BUTTON_COLOR_BG:uint = COLOR_PRIMARY;
		public static const SIDE_BUTTON_COLOR_BG_DOWN:uint = COLOR_TERTIARY;
		public static const SIDE_BUTTON_COLOR_BAR:uint = COLOR_TERTIARY;
		// main menu
		public static const MAIN_MENU_COLOR_TITLE:uint = COLOR_SECONDARY;
		// layers panel
		public static const LAYERS_BUTTON_COLOR_LABEL:uint = COLOR_SECONDARY;
		// info panel
		public static const INFO_COLOR_TEXT:uint = COLOR_SECONDARY;
		public static const INFO_COLOR_TEXT_ALT:uint = COLOR_SECONDARY;
		// toast
		public static const TOAST_COLOR_BG:uint = COLOR_SECONDARY;
		public static const TOAST_COLOR_BAR:uint = COLOR_TERTIARY;
		public static const TOAST_COLOR_TEXT:uint = COLOR_PRIMARY;
		// markers
		public static const MARKER_PERSON:uint = 0xFF22FF;
		public static const MARKER_PERSON_MOVE:uint = 0x2222FF;
		public static const MARKER_BG:uint = COLOR_PRIMARY;
		public static const MARKER_BG_ROUTE:uint = COLOR_TERTIARY;
		public static const MARKER_INDEX_COLOR_TEXT:uint = COLOR_SECONDARY;
		// map
		public static const MAP_COLOR_LABEL:uint = COLOR_SECONDARY;
		// route HUD
		public static const ROUTE_HUD_COLOR_TEXT:uint = COLOR_SECONDARY;
		
		/**
		 * Fonts
		 */
		// panels
		public static const PANEL_FORMAT_TITLE:TextFormat = new TextFormat("Akzidenz-Grotesk BQ Condensed", 30, PANEL_COLOR_TITLE, true);
		// buttons
		public static const BUTTON_FORMAT_LABEL:TextFormat = new TextFormat("Akzidenz-Grotesk BQ Light Conde", 20, BUTTON_COLOR_LABEL, false, false, false, null, null, "center");
		public static const BUTTON_LONG_FORMAT_LABEL:TextFormat = new TextFormat("Akzidenz-Grotesk BQ Light Conde", 20, BUTTON_COLOR_LABEL, false, false, false, null, null, "left");
		// main menu
		public static const MAIN_MENU_FORMAT_TITLE:TextFormat = new TextFormat("Akzidenz-Grotesk BQ Light Conde", 30, MAIN_MENU_COLOR_TITLE, false, false, false, null, null, "left");
		// layers panel
		public static const LAYERS_BUTTON_FORMAT_LABEL:TextFormat = new TextFormat("Akzidenz-Grotesk BQ Light Conde", 24, LAYERS_BUTTON_COLOR_LABEL, false, false, false, null, null, "left");
		// info panel
		public static const INFO_FORMAT_TEXT:TextFormat = new TextFormat("Arial", 16, INFO_COLOR_TEXT);
		public static const INFO_FORMAT_TEXT_ALT:TextFormat = new TextFormat("Akzidenz-Grotesk BQ Light Conde", 20, INFO_COLOR_TEXT_ALT, false);
		public static const INFO_FORMAT_TEXT_LARGE:TextFormat = new TextFormat("Akzidenz-Grotesk BQ Condensed", 40, INFO_COLOR_TEXT_ALT, true);
		public static const INFO_FORMAT_INDEX:TextFormat = new TextFormat("Akzidenz-Grotesk BQ Light Conde", 24, COLOR_PRIMARY, false, false, false, null, null, "left");
		// toast
		public static const TOAST_FORMAT_TITLE:TextFormat = new TextFormat("Arial", 16, TOAST_COLOR_TEXT, true);
		public static const TOAST_FORMAT_MSG:TextFormat = new TextFormat("Arial", 12, TOAST_COLOR_TEXT);
		// markers
		public static const MARKER_INDEX_FORMAT_TEXT:TextFormat = new TextFormat("Akzidenz-Grotesk BQ Condensed", 16, MARKER_INDEX_COLOR_TEXT, true);
		// map
		public static const MAP_FORMAT_LABEL:TextFormat = new TextFormat("Arial", 12, MAP_COLOR_LABEL);
		// route HUD
		public static const ROUTE_HUD_FORMAT_TEXT:TextFormat = new TextFormat("Arial", 12, ROUTE_HUD_COLOR_TEXT);

	}

}