package map
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.geom.Vector3D;
	import flash.events.TouchEvent;
	import flash.events.MouseEvent;
	import flash.events.GestureEvent;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import ui.panel.PanelEvent;
	
	/**
	 * ...
	 * @author Cassandra de Git and Charlie Chao
	 */
	public class Location extends Node 
	{
		/**
		 * Constants
		 */
		public static const ICON_SIZE:int = 48;
		
		/**
		 * Attributes
		 */
		public var id:String;
		private var icon:Bitmap;
		
		// Should also have an associated image, plus the info for the pop up?
		
		public function Location(idx:int, n_Pos:Vector3D, id:String, iconData:BitmapData) 
		{
			super(idx, n_Pos);
			this.id = id;
			cacheAsBitmap = true;
			
			if (iconData != null) { // has an icon...
				// load icon
				icon = new Bitmap(iconData);
				icon.x = -icon.width / 2;
				icon.y = (ICON_SIZE - icon.height) / 2 - ICON_SIZE - 8;
				addChild(icon);
				
				// add event listeners
				//this.addEventListener(TouchEvent.TOUCH_TAP, clickHandler);
				addEventListener(MouseEvent.CLICK, clickHandler);
			}
		}
		
		override public function render():void
		{
			// TODO: make invisible
			
			// draw marker
			if (icon != null) {
				//graphics.beginFill(fillColor);
				//graphics.drawCircle(0, 0, 2);
				//graphics.endFill();
				graphics.beginFill(CommonStyle.MARKER_BG);
				graphics.drawRect( -ICON_SIZE / 2, -ICON_SIZE - 8, ICON_SIZE, ICON_SIZE);
				graphics.moveTo( -5, -8);
				graphics.lineTo(5, -8);
				graphics.lineTo(0, 0);
				graphics.endFill();
			}
		}
		
		private function clickHandler(event:MouseEvent):void
		{
			if (Main.selectedDestination == -1)
				dispatchEvent(new PanelEvent(PanelEvent.PANEL_OPEN, { panel: Main.PANEL_INFO, id: id }));
			//dispatchEvent(new NodeClicked(NodeClicked.NODE_CLICKED, this, true));
		}
	}

}