package map
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import ui.StateEvent;

	/**
	 * MapData
	 * 
	 * @author Charlie Chao
	 */
	public class MapData extends EventDispatcher
	{
		/**
		 * Attributes
		 */
		private var jsonLoader:URLLoader;
		public var locations:Object;
		public var activities:Object;
		
		public function MapData(source:String) 
		{
			jsonLoader = new URLLoader(); 
			jsonLoader.addEventListener(Event.COMPLETE, jsonLoaded);
			jsonLoader.addEventListener(IOErrorEvent.IO_ERROR, jsonFailed);
			jsonLoader.load(new URLRequest(source));
		}
		
		// json load failure handler
		private function jsonFailed(e:IOErrorEvent):void 
		{
			trace("Failed loading resource!");
			dispatchEvent(new StateEvent(StateEvent.FAILED));
		}
		
		// loads json data
		private function jsonLoaded(e:Event):void 
		{
			// get json data
			var data:Object = JSON.parse(String(URLLoader(jsonLoader).data));
			locations = data.locations;
			activities = data.activities;
			
			// close json loader
			jsonLoader.close();
			jsonLoader = null;
			
			dispatchEvent(new StateEvent(StateEvent.READY));
		}
		
		// returns location
		public function getLocation(id:String):Object 
		{
			if (id != null && id != "") {
				for (var i:int = 0; i < locations.length; i++)
					if (locations[i].id == id) return locations[i];
			} 
			return null;
		}
		
		// returns activities
		public function getActivity(id:String):Object
		{
			if (id != null && id != "") {
				for (var i:int = 0; i < activities.length; i++)
					if (activities[i].id == id) return activities[i];
			}
			return null;
		}
	}

}