package map 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.Vector3D;
	import com.greensock.TweenLite;
	import com.greensock.easing.Sine;

	/**
	 * Person
	 * 
	 * @author Charlie Chao
	 */
	public class PersonMarker extends Sprite
	{
		/**
		 * Constants
		 */
		public static const MOVE_DURATION:Number = 1;		// move duration 
		
		/**
		 * Components
		 */
		public var icon:Bitmap;
		 
		/**
		 * Attributes
		 */
		public var node:Node;
		public var moving:Boolean;
		
		public function PersonMarker(node:Node, iconData:BitmapData) 
		{
			setNode(node);
			moving = false;
			//render();
			icon = new Bitmap(iconData);
			icon.x = -icon.width / 2;
			icon.y = -icon.height;
			addChild(icon);
			
			// add events
			addEventListener(MouseEvent.CLICK, mouseClick);
		}
		
		// renders marker
		public function render():void 
		{
			//graphics.clear();
			//graphics.beginFill((moving)?CommonStyle.MARKER_PERSON_MOVE:CommonStyle.MARKER_PERSON);
			//graphics.moveTo(0, 0);
			//graphics.lineTo(0, -25);
			//graphics.lineTo(15, -25);
			//graphics.lineTo(15, -5);
			//graphics.lineTo(5, -5);
			//graphics.lineTo(0, 0);
			//graphics.endFill();
		}
		
		// set person node
		public function setNode(newNode:Node):void
		{
			node = newNode;
			TweenLite.killTweensOf(this);
			TweenLite.to(this, MOVE_DURATION, { x: node.x, y: node.y, ease: Sine.easeOut } );
			//x = node.x;
			//y = node.y;
		}
		
		// toggles move
		public function mouseClick(e:MouseEvent):void
		{
			if (!moving) {
				moving = true;
				render();
				stage.addEventListener(MouseEvent.MOUSE_MOVE, mouseMove);
				stage.addEventListener(MouseEvent.CLICK, mouseClickGlobal, false, 1);
				e.stopImmediatePropagation();
			}
		}
		
		// cancels moving the person
		public function mouseClickGlobal(e:MouseEvent):void 
		{
			e.stopImmediatePropagation();
			moving = false;
			render();
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, mouseMove);
			stage.removeEventListener(MouseEvent.CLICK, mouseClickGlobal);
			//parent.dispatchEvent(new MouseEvent(MouseEvent.RIGHT_CLICK, true));
		}
		
		// moving the person
		public function mouseMove(e:MouseEvent):void 
		{
			x = parent.mouseX;
			y = parent.mouseY;
		}
		
	}

}