package map
{
	/**
	 * ...
	 * @author Cassandra de Git and Charlie Chao
	 */
	public class RoutePlanner 
	{
		// Stores a queue of nodes that the user can add to
		// Finds the shortest distance between each set of nodes
		// Plots one single path using these routes
		
		private var nodes:Array = new Array();
		private var route:Array = new Array();		// Array of the Edges that make up the route
		
		private var currentIndex:int = 0;
		
		public function RoutePlanner() 
		{
			
		}
		
		public function addNode(node:Node, index:int):void
		{
			// Adds the node at the desired location
			nodes.splice(index, 0, node);
			if (index == currentIndex) {
				currentIndex++;
			}
		}
		
		public function removeNode(index:int):void
		{
			// Removes the desired element from the queue
			nodes.splice(index, 1);
		}
		
		public function modifyNode(index:int, newNode:Node):void
		{
			// Select a node, change it to another node
			removeNode(index);
			addNode(newNode, index);
		}
		
		public function getCurrentIndex():int
		{
			return currentIndex;
		}
		
		public function getNodes():Array
		{
			return nodes;
		}
		
	}

}