package ui 
{

	import flash.display.Sprite;
	import ui.button.LayersButton;
	import com.greensock.TweenLite;
	
	/**
	 * LayersPanel
	 * 
	 * @author Charlie Chao
	 */
	public class LayersPanel extends Sprite 
	{
		// constants
		public static const WIDTH:int = 200;
		public static const DURATION_FADE:Number = 0.2;
		
		// attributes
		private var layers:Vector.<LayersButton>;
		
		public function LayersPanel(sprites:Spritesheet) 
		{
			super();
			visible = false;
			alpha = 0;
			
			// setup layers buttons
			var i:int;
			layers = new Vector.<LayersButton>;
			i = layers.push(new LayersButton("Trails", 15, 15+ i * LayersButton.BUTTON_HEIGHT, WIDTH - 15, sprites.getSprite("layers_trails"), sprites.getSprite("layers_trails_alt")));
			i = layers.push(new LayersButton("Labels", 15, 15+ i * LayersButton.BUTTON_HEIGHT, WIDTH - 15, sprites.getSprite("layers_labels"), sprites.getSprite("layers_labels_alt")));
			i = layers.push(new LayersButton("Facilities", 15, 15+ i * LayersButton.BUTTON_HEIGHT, WIDTH - 15, sprites.getSprite("layers_facilities"), sprites.getSprite("layers_facilities_alt")));
			i = layers.push(new LayersButton("Tree Density", 15, 15+ i * LayersButton.BUTTON_HEIGHT, WIDTH - 15, sprites.getSprite("layers_trees"), sprites.getSprite("layers_trees_alt")));
			
			// add layers buttons and listen
			for each (var l:LayersButton in layers) {
				addChild(l);
				l.listen();
			}
			
			// draw background
			//graphics.clear();
			//graphics.beginFill(CommonStyle.SIDE_BUTTON_COLOR_BG);
			//graphics.drawRect(0, 0, 15+ WIDTH, 15+ height);
			//graphics.endFill();
			
			graphics.clear();
			graphics.beginFill(CommonStyle.SIDE_BUTTON_COLOR_BG);
			graphics.drawRoundRectComplex(0, 0, 15+ WIDTH, 15+ LayersButton.BUTTON_HEIGHT * layers.length-1+15, 0, 0, 32, 0);
			graphics.endFill();
		}
		
		// fade in
		public function fadeIn():void 
		{
			visible = true;
			TweenLite.killTweensOf(this);
			TweenLite.to(this, DURATION_FADE, { alpha: 1 } );
		}
		
		// fade out
		public function fadeOut():void 
		{
			TweenLite.killTweensOf(this);
			TweenLite.to(this, DURATION_FADE, { alpha: 0, onComplete: function():void { visible = false; }} );
		}
		
	}

}