package ui.button
{
	import flash.display.BitmapData;
	import flash.events.MouseEvent;
	import ui.panel.Panel;
	import ui.panel.PanelEvent;

	/**
	 * LinkedPanelButton
	 * 
	 * @author Charlie Chao
	 */
	public class LinkedPanelButton extends FlatButton 
	{
		// attributes
		public var linkedPanel:int;
		
		public function LinkedPanelButton(labelText:String, x:int, y:int, width:int, height:int, iconData:BitmapData, linkedPanel:int)
		{
			super(labelText, x, y, width, height, iconData);
			this.linkedPanel = linkedPanel;
		}
		
		// opens panel
		protected function openPanel(e:MouseEvent):void 
		{
			dispatchEvent(new PanelEvent(PanelEvent.PANEL_OPEN, { panel: linkedPanel }));
		}
		
		// attachs panel opening listener
		override public function listen():void {
			super.listen();
			addEventListener(MouseEvent.CLICK, openPanel);
		}
		
		// detaches panel opening listener
		override public function unlisten():void {
			super.unlisten();
			if (hasEventListener(MouseEvent.CLICK)) removeEventListener(MouseEvent.CLICK, openPanel);
		}		
	}

}