package ui.button 
{

	import flash.display.BitmapData;
	import flash.events.Event;
	import ui.panel.Panel;
	
	/**
	 * LongButton
	 * 
	 * @author Charlie Chao
	 */
	public class LongButton extends FlatButton 
	{
		
		public var infoID:String;
		
		public function LongButton(labelText:String, x:int, y:int, width:int, height:int, iconData:BitmapData, id:String = null) 
		{
			super(labelText, x, y, width, height, iconData);
			infoID = id;
			label.defaultTextFormat = CommonStyle.BUTTON_LONG_FORMAT_LABEL;
			label.text = labelText;
		}
		
		// renders the button
		override public function render(e:Event = null):void 
		{
			super.render(e);
			
			// determine spacing
			var spaceH:int = (48 - icon.width) / 2;
			var space:int = (buttonHeight - icon.height) / 2;
			
			// re-position elements
			icon.x = spaceH;
			icon.y = space;
			if (label != null) {
				label.x = 48 + Panel.PADDING;
				label.y = buttonHeight / 2 - label.height / 2;
			}
		}
	}

}