package ui.panel
{
	import flash.events.Event;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import ui.button.MenuButton;
	import ui.Spritesheet;

	/**
	 * MainMenuPanel
	 * 
	 * @author Charlie Chao
	 */
	public class MainMenuPanel extends Panel 
	{
		/**
		 * Constants
		 */
		public static const WIDTH:int = 300;
		public static const BUTTONS_WIDTH:int = WIDTH - PADDING * 2;
		public static const BUTTONS_OFFSET:int = 200;
		public static const BUTTONS_SPACING:int = 20;
		
		/**
		 * Components
		 */
		private var buttonActivities:MenuButton;
		private var buttonFacilities:MenuButton;
		private var buttonEvents:MenuButton;
		private var buttonsAbout:MenuButton;
		
		public function MainMenuPanel() 
		{
			super(WIDTH, Main.CATEGORY_MAIN_MENU, "side_button_main_menu", "central_park"); // TODO: image
			title.text = "Central Park";
		}
		
		// initializes the buttons
		override public function constructButtons(panels:Vector.<Panel>):void
		{
			// setup buttons
			var buttonY:int = BUTTONS_OFFSET + PADDING * 2;
			buttonActivities = new MenuButton("Activities", PADDING, buttonY, BUTTONS_WIDTH, uiSpriteSheet.getSprite("main_menu_activities"), Main.PANEL_ACTIVITIES);
			buttonY += MenuButton.BUTTON_HEIGHT + BUTTONS_SPACING;
			buttonFacilities = new MenuButton("Points of Interest", PADDING, buttonY, BUTTONS_WIDTH, uiSpriteSheet.getSprite("main_menu_facilities"), Main.PANEL_FACILITIES);
			buttonY += MenuButton.BUTTON_HEIGHT + BUTTONS_SPACING;
			buttonEvents = new MenuButton("Events", PADDING, buttonY, BUTTONS_WIDTH, uiSpriteSheet.getSprite("main_menu_events"), Main.PANEL_EVENTS);
			buttonY += MenuButton.BUTTON_HEIGHT + BUTTONS_SPACING;
			buttonsAbout = new MenuButton("About", PADDING, buttonY, BUTTONS_WIDTH, uiSpriteSheet.getSprite("main_menu_about"), Main.PANEL_ABOUT);
			
			// add to screen
			addChild(buttonActivities);
			addChild(buttonFacilities);
			addChild(buttonEvents);
			addChild(buttonsAbout);
		}
		
	}

}