package ui.panel
{
	import flash.events.Event;
	import flash.events.MouseEvent;
	import map.MapEvent;
	import ui.button.FlatButton;
	import ui.button.QuickFindButton;
	import ui.Spritesheet;

	/**
	 * QuickFindPanel
	 * 
	 * @author Charlie Chao
	 */
	public class QuickFindPanel extends Panel 
	{
		/**
		 * Constants
		 */
		public static const WIDTH:int = 260;
		public static const BUTTONS_WIDTH:int = WIDTH;
		public static const BUTTONS_HEIGHT:int = 120;
		public static const BUTTONS_OFFSET:int = 200;
		public static const BUTTONS_SPACING:int = 0;
		
		/**
		 * Components
		 */
		public var btnWashroom:FlatButton;
		public var btnParking:FlatButton;
		public var btnPicnic:FlatButton;
		public var btnTrash:FlatButton;
		
		public function QuickFindPanel() 
		{
			super(WIDTH, Main.CATEGORY_QUICK_FIND, "side_button_quick_find", "quick_find"); // TODO: icon
			title.text = "Quick Find";
			
			// setup buttons
			var buttonWidth:int = WIDTH - PADDING * 2;
			var buttonY:int = 0;
			btnWashroom = new QuickFindButton(null, 0, buttonY, BUTTONS_WIDTH, BUTTONS_HEIGHT, uiSpriteSheet.getSprite("quick_find_washroom_alt"));
			buttonY += BUTTONS_HEIGHT + BUTTONS_SPACING;
			btnParking = new QuickFindButton(null, 0, buttonY, BUTTONS_WIDTH, BUTTONS_HEIGHT, uiSpriteSheet.getSprite("quick_find_parking_alt"));
			buttonY += BUTTONS_HEIGHT + BUTTONS_SPACING;
			btnPicnic = new QuickFindButton(null, 0, buttonY, BUTTONS_WIDTH, BUTTONS_HEIGHT, uiSpriteSheet.getSprite("quick_find_picnic_alt"));
			buttonY += BUTTONS_HEIGHT + BUTTONS_SPACING;
			btnTrash = new QuickFindButton(null, 0, buttonY, BUTTONS_WIDTH, BUTTONS_HEIGHT, uiSpriteSheet.getSprite("quick_find_trash_alt"));
			
			// adds buttons to container
			content.add(btnWashroom);
			content.add(btnParking);
			content.add(btnPicnic);
			content.add(btnTrash);
			addChild(content);
		}
		
		// added to screen handler
		override public function added(e:Event = null):void 
		{
			super.added(e);
			btnWashroom.addEventListener(MouseEvent.CLICK, findWashroom);
			btnParking.addEventListener(MouseEvent.CLICK, findParking);
			btnPicnic.addEventListener(MouseEvent.CLICK, findPicnic);
			btnTrash.addEventListener(MouseEvent.CLICK, findTrash);
		}
		
		// removes the panel from screen and removes all the listeners
		override protected function dispose():void 
		{
			super.dispose();
			if (btnWashroom.hasEventListener(MouseEvent.CLICK)) btnWashroom.addEventListener(MouseEvent.CLICK, findWashroom);
			if (btnParking.hasEventListener(MouseEvent.CLICK)) btnParking.addEventListener(MouseEvent.CLICK, findParking);
			if (btnPicnic.hasEventListener(MouseEvent.CLICK)) btnPicnic.addEventListener(MouseEvent.CLICK, findPicnic);
			if (btnTrash.hasEventListener(MouseEvent.CLICK)) btnTrash.addEventListener(MouseEvent.CLICK, findTrash);
		}
		
		// find nearest washroom
		public function findWashroom(e:MouseEvent = null):void 
		{
			dispatchEvent(new MapEvent(MapEvent.CHANGE, "qf_washroom"));
		}
		
		// find nearest parking
		public function findParking(e:MouseEvent = null):void 
		{
			dispatchEvent(new MapEvent(MapEvent.CHANGE, "qf_parking"));
		}
		
		// find nearest picnic
		public function findPicnic(e:MouseEvent = null):void 
		{
			dispatchEvent(new MapEvent(MapEvent.CHANGE, "qf_picnic"));
		}
		
		// find nearest trash
		public function findTrash(e:MouseEvent = null):void 
		{
			dispatchEvent(new MapEvent(MapEvent.CHANGE, "qf_trash"));
		}
		
	}

}